/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  *
  * Title : 		Javascript actions to handle Ajax and processing for the todo list
  * Author : 		Ryan Campbell
  * URL : 		http://particletree.com
  *
  * Description :	Handles add, remove, and mark complete and maintains the alterations of the markup
  *
  * Created : 	8/18/2005
  * Modified : 	8/22/2005
  *
 - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*/

/*------------------------------------------- PAGE LOAD -----------------------------------------------------*/ 
 
/*
  * Summary:	Call these functions on page load to set up degradable Ajax
  */
addEvent(window, 'load', buildAjax);
var activeID;

function buildAjax() {
	enabledCheckboxes();
	disableLinks();
	disableForms();
}

function disableLinks() {
    var links = document.getElementsByTagName("a");
	
    for (i=0; i<links.length; i++){
        var link = links[i];
		if(link.className != "") {
			link.onclick = allFuncs[getAction(link.className)];
			if(link.title == "Complete this Item") {
				link.style.display = "none";
			}
		}
    }
}

function disableForms() {
    var forms = document.getElementsByTagName("form");

    for (y=0; y<forms.length; y++){
        var form = forms[y];
        form.onsubmit = allFuncs[getAction(form.className)];
    }
}

function enabledCheckboxes() {
	var inputs = document.getElementsByTagName("input");

    for (i=0; i<inputs.length; i++){
        var input = inputs[i];
        if(input.className == "checkbox") {
			input.style.display = "inline";
			input.onclick = allFuncs["CompleteItem"];
		}
    }
}

var allFuncs = new Object();

/*------------------------------------------- ADD ITEM -----------------------------------------------------*/ 

/*
  * Summary:	Add Item to list
  *			The next 2 functions handle adding an item to the list and displaying it properly
  */
var ajaxNewItem;

allFuncs["addToList"] = function() { 
	url = "http://localhost/xslTodo/processList.php?action=add&ajax=yes";
    data = "&itemDesc=" + $F("itemDesc");
	var myAjax = new Ajax.Request(
		url,
		{method: 'post', parameters: data, onComplete: addItemResults}
	);
	return false; 
}

function addItemResults(oReq) {
	activeID = "notdone";
	getMarkup("notcomplete");
}

/*------------------------------------------- DELETE ITEM -----------------------------------------------------*/ 

/*
  * Summary:	Delete Item From list
  *			The next 2 functions handle deleting an from the list and displaying it properly
  */
var ajaxDeleteItem;

allFuncs["DeleteItem"] = function() { 
	activeID = right(this.id, this.id.length - 1);
	url = "http://localhost/xslTodo/processList.php?action=delete&ajax=yes&id=" + activeID;
    data = "";
	var myAjax = new Ajax.Request(
		url,
		{method: 'post', parameters: data, onComplete: deleteItemResults}
	);
	return false; 
}

function deleteItemResults() {
	nodeToRemove = $("list" + activeID);
	nodeToRemove.parentNode.removeChild(nodeToRemove);
	enabledCheckboxes();
	disableLinks();
	disableForms();
}

/*------------------------------------------- COMPLETE ITEM -----------------------------------------------------*/ 

/*
  * Summary:	Mark item as completed
  *			The next 2 functions handle completing an item and displaying it properly
  */
var ajaxCompleteItem;;

allFuncs["CompleteItem"] = function() { 
	activeID = right(this.id, this.id.length - 1);
	url = "http://localhost/xslTodo/processList.php?action=complete&ajax=yes&id=" + activeID;
    data = "";
	var myAjax = new Ajax.Request(
		url,
		{method: 'post', parameters: data, onComplete: completeItemResults}
	);
	return false; 
}

function completeItemResults(oReq) {
	nodeToRemove = document.getElementById("list" + activeID);
	nodeToRemove.parentNode.removeChild(nodeToRemove);
	activeID = "done";
	getMarkup("arecomplete");
}

/*------------------------------------------- HANDLE MARKUP -----------------------------------------------------*/ 

/*
  * Summary:	Build display objects
  */
  
function getMarkup(status) {
	url = "http://localhost/xslTodo/processList.php?action="+status+"&ajax=yes";
    data = "";
	var myAjax = new Ajax.Request(
		url,
		{method: 'post', parameters: data, onComplete: changeMarkup}
	);
}

function changeMarkup(oReq) {
	$(activeID).innerHTML = oReq.responseText;
	enabledCheckboxes();
	disableLinks();
	disableForms();
}
  